#!/usr/bin/perl
$name = $ARGV[0];
@parsed_name = split(/\./, $name);

open(OUT, ">test.trace");
$count = 1;
while ( <STDIN> ) {
        $line = $_;
	# Pattern Jul 10 19:20:21 anders2 kernel: Diff=339198, pktlen=74
	# Pattern  0 0 0 0 604768  28412 318084 0 0 4 71 59 48 9 1 90
        if ( $_ =~ /\b(\w+)\ *(\d+)\ *(\d+):(\d+):(\d+)\ *(\w+)\ *(\w+):\ *Diff=(\d+),\ *pktlen=(\d+)(.*)$/ ) {
		print OUT "$count $8 $9\n";
        	$count++;
	}
}
close(OUT);
# Create the raw trace file
system "mv test.trace $parsed_name[0].trace";

# Change the parameters in time_series_orig.gpl and hist_orig.R
system "sed -e 's/100Mbps/$parsed_name[0]/g' time_series_orig.gpl > time_series.gpl";
system "sed -e 's/100Mbps/$parsed_name[0]/g' hist_orig.R > histogram.R"; 
system "sed -e '1,10d' $parsed_name[0].trace > new.trace";
system "mv new.trace $parsed_name[0].trace";

# Call the time-series generator
system "gnuplot time_series.gpl";

# Add a header to generate histograms
system "cat - $parsed_name[0].trace <<<'seq diff pktlen'> new.trace";
system "rm $parsed_name[0].trace";
system "mv new.trace $parsed_name[0].trace";

#system "R --no-save < histogram.R";
system "rm time_series.gpl";
#system "rm histogram.R";
