rm(list=ls())
x = read.table(file="100Mbps.trace", header=T)
png("100Mbps_hist_5msec.png")
hist((x[['diff']])/1000, xlim=range(0,5000), br=200000, main="Histogram Packet dispersion (5 msec)", xlab="(in mu_sec)", probability=T)
#rug(jitter((x[['diff']])/1000))
dev.off()
png("100Mbps_hist_1msec.png")
hist((x[['diff']])/1000, xlim=range(0,1000), br=200000, main="Histogram Packet dispersion (1 msec)", xlab="(in mu_sec)", probability=T)
dev.off()
png("100Mbps_hist_40usec.png")
hist((x[['diff']])/1000, xlim=range(0,40), br=9000000, main="Histogram Packet dispersion (40 usec)", xlab="(in mu_sec)", probability=T)
dev.off()
png("100Mbps_boxplot.png")
boxplot((x[['diff']]/1000))
dev.off()
